import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to get and list the root of the schema tree
  *
  * usage: java GetSchema
  */
class GetSchema {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("ou=People");

	    // List contents of root
	    NamingEnumeration bds = schema.list("");
	    while (bds.hasMore()) {
		System.out.println(((NameClassPair)(bds.next())).getName());
	    }
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
